MODEL TINY
P286N
IDEAL
JUMPS
  ;Kntj TASM

  ;VgaBlank on kuvaruudunpimennysohjelma VGA-nytlle. Kuvan voi
  ;piment painamalla ScrollLockia.
  ;
  ;Versio 4.1a, 12.4.1994
  ;
  ;Historia:
  ;4.1 26.8.1993
  ; Koodin viilailua lyhyemmksi. Jrjestys on poikkeava: TSR-osuus
  ; on jossain keskipaikkeilla, sstyyphn yksi hyppyksky alusta.
  ;4.0: 18.3.1993
  ; TSR-osuus uusittu. ScrollLock-nppint ei en tunnisteta BIOSsin
  ; muistipaikan bittien avulla, vaan kytetn make-koodia, joka toimii
  ; Windowsissa paremmin. On valitettavasti hieman monimutkaisempi tapa.
  ; Muistinkulutus nousi 160 tavusta 176 tavuun.
  ;3.1: 20.7.1992
  ; Listty kill-parametri
  ; MainProcin koodia muutettu enemmn FastRatin kaltaiseksi (siistimpi)
  ;3.0: 22.11.1991
  ; Pivitetty Dos 5:lle lismll tuki UMB:lle
  ; Muistinkulutus lienee pudonnut 16 tavua.
  ;1.0 - <3.0:
  ; Osin hmrn peitossa. 1.0 toimi primitiivisesti asettamalla paletit
  ; mustaksi ja palauttamalla paletit, kun kuva piti saada takaisin.
  ; Muistinkulutus lienee ollut 0.5 kilon luokkaa. Liek ollut 2.0, jossa
  ; kytettiin BIOS-keskeytyst kuvan pimentmiseen.
  ; Moni versio toi pienemmn muistinkulutuksen.

NoParams    equ 0	     ;Komentoriviparametreja kuvaavat
CaseOn      equ 1            ;vakiot
CaseOff     equ 2
CaseKill    equ 3
CaseUnknown equ 0ffffh

  CODESEG

  org 5ch	        ;FCB1:n offsetti PSP:ss
  OldKeyInt DD ?        ;Vanha nppimistkeskeytys
  LastCode  DB ?        ;Edellinen make- tai break-koodi
  IsBlack   DB ?        ;1, jos kuva pime
  Active    DB ?        ;1, jos ohjelma aktiivimoodissa
  LABEL FreeArea WORD   ;Tnne kopioidaan TSR-osa

  STARTUPCODE		;Org 100h

PROC MainProc           ;TSR-osan lataus ja ksittely
  call Init             ;Muuttaa TSRSeg- ja Installed- muuttujia
                        ;Palauttaa parametrin ax:ss
  cmp ax,NoParams
  jne @@F1              ;Annettu jotain parametreja -> hypp
  cmp [Installed],1	;Ei parametreja, onko installoitu?
  jne Install		;Jos ei, niin hyptn installointiin
  mov bx,offset Already ;Olikin jo muistissa
  jmp NameExit		

 @@F1:                  ;Parametri annettu, mutta mik?
  cmp ax, CaseUnknown   ;Tuntematon parametri?
  je Help
  cmp [Installed],1
  je @@F2
  mov bx,offset NotFound;ei lydy muistista
  jmp NameExit          ;On annettu parametreja, mutta ohjelmaa

 @@F2:                  ;Ohjelma on muistissa, mitenks parametrit?
  cmp ax,CaseOff        ;'off'
  je SetOff
  cmp ax,CaseKill       ;'kill'
  je Kill

;Ei jnyt muita mahdollisuuksia kuin 'on' :
SetOn:                  ;Vgablankin uudelleen aktivointi

  mov es,[TSRSeg]       ;Residentin osan segmentti
  mov [byte es:Active],1   ;Muutetaan residentin osan muuttujia
  mov [word es:LastCode],0 ;LastCode := 0 ja IsBlack := 0
  mov dx,offset OnMsg	;Kerrotaan, ett on taas pll
  jmp TextExit

Help:

  mov dx, Offset HelpMsg
  jmp TextExit

SetOff:                 ;Vgablankin deaktivointi

  call Deactivate       ;Pois plt + kuva nkyviin
  mov bx,offset OffMsg
  jmp NameExit

Kill:                   ;Koitetaan poistaa TSR-ohjelma muistista

  call Deactivate       ;Ensin pois plt + kuva nkyviin
  ;es:bx pannaan osoittamaan TSR-koodiin, Deactivate asetti jo es:n
  mov  bx,Offset FreeArea
  call NormalizePtr     ;ja normalisoidaan vertailua varten
  mov  si,dx            ;TSR:n seg talteen
  mov  di,bx            ;TSR:n ofs talteen
  mov  ax, 3509h
  int  21h              ;Pyyd nppinkeskeytyksen osoite
  call NormalizePtr     ;Offsetti 0:ksi tai mahd. pieneksi
  cmp  bx, di
  jne  Error		;Virhe, jos VgaBlankin residentti osa
  cmp  dx, si           ;ei ole tmnhetkisen 
  jne  Error            ;nppinkeskeytyksen

  mov  ax,2509h         ;Aseta keskeytys 09h
  mov  es,[TSRSeg]	;Uusi keskeytysosoite residentin osan muuttujasta,
  mov  dx,[word es:OldKeyInt] ;jossa on alkuperisen keskeytyksen osoite
  push ds
  mov  ds,[word es:OldKeyInt+2]
  int  21h              ;ds:dx osoittaa OldKeyInt:iin
  pop  ds

  mov ah, 49h           ;es:ss valmiina TSRSeg
  int 21h               ;Vapauta muistilohko
  jc  Error
  mov bx,offset KillMsg ;Ok
  jmp NameExit

 Error:
  mov bx,offset NoKillMsg ;Tuli joku virhe, TSR-osa on kuitenkin deaktivoitu
  jmp NameExit

Install:

  mov dx,offset InstMsg
  mov ah,9
  int 21h               ;Kerrotaan infoa

  mov [Active],1
  mov [word LastCode],0 ;LastCode := 0 ja IsBlack := 0
  mov ax,3509h          ;Lue keskeytyksen 9 osoite
  int 21h

  mov [word OldKeyInt],bx
  mov [word OldKeyInt+2],es  ;Tallessa on

  mov es,[cs:002ch]     ;PSPss on ympristn segmentti
  mov ah,49h
  int 21h               ;Vapauta ymprist

  push ds
  pop es                ;Ohjelman oma segmentti
  mov di,offset FreeArea
  mov si,offset TSRProc
  mov cx,offset EndTSR -  offset TSRProc ;TSR-osan pituus cx:n
  rep movsb             ;Kopioidaan TSR-osa PSP-alueelle

  mov ax,2509h
  mov dx,offset FreeArea ;Uuden keskeytyksen offsetti
  int 21h               ;Asetetaan uusi keskeytys

  mov ax,3100h
  mov dx,di             ;di:ss on TSR:n viimeinen offsetti + 1
  add dx,0fh            ;Listn 15, koska ==>
  shr dx,4              ;==> Tavut div 16
  int 21h               ;Terminate and stay resident
;Installointi loppuu thn.
  
NameExit:               ;Nytt NameStr:n
  mov ah,9              ; + tekstin, johon bx osoittaa
  mov dx, Offset NameStr; + lopettaa ohjelman ajon.
  int 21h
  mov dx,bx

TextExit:               ;Poistutaan ohjelmasta, ja nytetn
  mov ah,9              ;teksti, jonka offsetti on dx:ss
  int 21h
  int 20h

ENDP

;----------------------------------------------------;
; TSR-koodi kopioidaan tlt PSP:hen                ;
;----------------------------------------------------;
PROC TSRProc                 ;Uusi keskeytys alkaa tst
  cmp [cs:Active],0
  je @@FastOut               ;Heti ulos, jos ei aktiivisena
  push ax
  push bx
  in  al,60h                 ;60h = nppinportti
  mov bh,al                  ;Talteen..
  cmp al,80h                 ;80h => break-koodi (nppin pstetty yls)
  jae @@Out
  cmp [cs:IsBlack],1         ;Onko kuva pimen?
  je  @@ShowIt               ;Jos on, niin nytetn
   ;Kuva ei ole pimen. Testataan onko ScrollLockin make-koodi, ja jos
   ;on, tarkistetaan ettei nppin ole painettu CtrlBreak:
  cmp al,70                  ;ScrollLockin ja CtrlBreakin makekoodi (=sama)
  jne @@Out                  ;Ei ole, joten ulos
  cmp [cs:LastCode],224      ;CtrlBreak aiheuttaa tmn ennen 70:t
  je  @@Out                  ;
  mov al,1                   ;Kuva pimeksi
  jmp @@Toggle
 @@ShowIt:
  xor al,al                  ;0 nytt kuvan
 @@Toggle:
  mov ah,12h                 ;al:ss on 0 tai 1
  mov [cs:IsBlack],al
  mov bl,36h
  int 10h
 @@Out:
  mov [cs:LastCode],bh
  pop bx
  pop ax
 @@FastOut:
  jmp [cs:OldKeyInt]         ;Se siit
ENDP
LABEL EndTSR WORD

;-Init osa 1------------------------------------------------------;
; Tm aliohjelma etsii ensimmisen MCB:n (Memory Control Block)  ;
;segmentin. Offsetti on aina 0. DOS varaa ohjelmille muistia aina ;
;16 tavun lohkoina. Muistia ksitelln 16 tavun sivuina, jotka   ;
;alkavat 16:lla jaollisista osoitteista. Jokaista lohkoa varten on;
;oma tietosivu, jonka avulla DOS hallitsee muistia. Tietosivun 1. ;
;tavu on 'M', toinen tavu kertoo tietosivun omistavan ohjelman    ;
;alkusivun. Jos se on 8, on kyseess systeemitiedosto. 0 merkitsee;
;vapaata muistia. Offsetissa 3 on muistipalan (ohjelman?) pituus  ;
;sivuina.                              				  ;
; Seuraavaksi tm aliohjelma etsii muistista TSRProc:in koodia.  ;
;Koodin pit olla muistilohkon alussa, muuten se olisi ei-       ;
;residenttin olevan VgaBlankin TSRProc, jota ei tietenkn ole	  ;
;tarkoitus etsi. Toinen ratkaisu olisi laittaa residentin osan   ;
;alkuun jokin merkkijono, jota etsittisiin.			  ;
;Jos ohjelmaa ei lydy, nollataan Installed. Jos lytyy, laitetaan;
;TSR-osan segmentti TSRSeg:iin, ja Installed saa arvon 1.         ;
;-----------------------------------------------------------------;
PROC Init
  mov ax,5802h
  int 21h               ; Get UMB link status
  jnc @LinkOk
  xor al,al
 @LinkOk:
  xor ah,ah
  push ax               ; Talleta link status
  mov ax,5803h
  mov bx,1              ; Avaa UMB
  int 21h
  mov ah,52h            ; Dokumentoimaton dos-funktio:
  int 21h               ; etsi"list of list" (es:bx)
  mov ax,[es:bx-2]      ; Edeltv tavu osoittaa 1. MCB:hen

  cld
  mov es,ax             ;1. MCB on ax:ss (tunnisteosa)
  xor bx,bx
@@NotYet:
  cmp [byte es:bx],'M'
  jne @@End
  mov dx,[es:bx+1]       ;1. tavun jlkeen on sana, joka osoittaa
  mov di,offset FreeArea ; tunnisteosan omistajaan (jota etsitn)
  ;Osoitteena on ohjelman alku, jossa pitisi olla tuttua koodia
  mov es,dx             ;ES:DI ohjelman osoite
  mov si,offset TSRProc ;DS:SI vgablankin tunnuksen osoite
  mov cx,20
  repe cmpsb            ;Verrataan 20 tavua ohjelmakoodia
  jcxz @@Found
  mov es,ax             ;Palautetaan es takaisin tunnisteosaan
  add ax,[es:bx+3]      ;Listn segmenttiin seuraavan lohkon pituus
  inc ax                ;Listn tunnisteosan pituus (1 sivu)
  mov es,ax             ;Uusi tunnisteosa
  jmp @@NotYet
@@Found:
  mov [Installed],1     ;Lytyi
  inc ax                ;Tunnistepalasta yksi eteenpin
  mov [TSRSeg],ax
@@End:
  mov ax,5803h
  pop bx                ; Palauta UMB status
  int 21h

 ;-Init osa 2----------------------------------;
 ;Tutkitaan onko ohjelmalle annettu parametreja;
 ;Palauttaa tilanteen rekisteriss ax          ;
 ;---------------------------------------------;
  push ds
  pop es
  mov bx,80h
  cmp [byte bx],0       ;Parametrijonon pituus
  je @@Empty
  mov cl,[byte bx]      ;Siirretn pituus laskuriksi
  xor ch,ch
  mov si,81h            ;1. merkki pituuden jlkeen
@@G1:
  and [byte si],0dfh    ;Muutetaan parametristringin kirjaimet isoiksi,
  inc si                ;pitisi toimia merkeille a-z, muut merkit voivat
  loop @@G1             ;muuttua joksikin muuksi, mutta se ei tss haittaa.
@@G3:                   ;Etsitn 1. ei-tyhj merkki
  inc bx
  cmp [byte bx],0dh     ;Enter?
  je @@Empty
  cmp [byte bx],0
  je @@G3
  cmp [byte bx],20h     ;Vlilynti?
  je @@G3
  cmp [byte bx],9h      ;Tab?
  je @@G3
  mov si,bx             ;bx: 1. ei-tyhjn merkin osoite
  mov di,offset ParaOn  ;Verrataan stringiin 'ON'
  mov cx,SIZE ParaOn
  repe cmpsb
  jne @@G4
  mov ax,CaseOn
  ret
@@G4:
  mov si,bx
  mov di,offset ParaOff ;Verrataan stringiin 'OFF'
  mov cx,SIZE ParaOff
  repe cmpsb
  jne @@G5
  mov ax, CaseOff
  ret
@@G5:
  mov si,bx
  mov di,offset ParaKill;Verrataan stringiin 'KILL'
  mov cx,SIZE ParaKill
  repe cmpsb
  jne @@Unknown         ;Jos cx>0 => tuntematon parametri
  mov ax,CaseKill
  ret
@@Unknown:
  mov ax,CaseUnknown
  ret
@@Empty:
  mov ax,NoParams
  ret
ENDP

;---------------------------------------------------------;
;Normalisoi pointterin eli muuttaa offsetin vlille 0-0fh.;
;Kutsu:                                                   ;
; es:bx  normalisoitava pointteri                         ;
;Palauttaa:                                               ;
; dx:bx  normalisoitu pointteri                           ;
; Tuhoaa: ax, dx                                          ;
;---------------------------------------------------------;
PROC NormalizePtr
  mov  ax, bx           ;offsetti ax:n
  shr  ax, 4            ;muuta ax segmenteiksi
  mov  dx, es
  add  dx, ax           ;ja lis segmenttiin
  and  bx, 0fh          ;jnns bx:n
  ret
ENDP

;------------------------------------------;
;Ottaa pimmennystoiminnan pois plt      ;
;------------------------------------------;
PROC Deactivate
  mov ax,1200h               ;Varmistetaan,
  mov bl,36h                 ;ett kuva on nkyviss
  int 10h
  mov es,[TSRSeg]
  mov bx,offset IsBlack      ;Merkitn kuva olemassaolevaksi ja
  mov [word es:bx],0         ;Active := false;
  ret
ENDP

  TSRSeg     dw ?        ;Muistissa olevan residentin osan segmentti
  Installed  db 0        ;Saa arvon 1, jos vgablank on jo muistissa
  ParaON     db 'ON'
  ParaOFF    db 'OFF'
  ParaKill   db 'KILL'

  InstMsg  db 13,10,'VgaBlank 4.1 nytn sammutin, Jarmo Aho ',13,10
	   db 'Kytt: paina [ScrollLock]',13,10,'$'
  HelpMsg  db 'Nytn sammutin VGAlle v 4.1',13,10,10
	   db 'Parametrit:',13,10
	   db 'off  -passivoi VgaBlankin ja vapauttaa'
	   db ' ScrollLockin muuhun kyttn',13,10
	   db 'on   -aktivoi VgaBlankin uudestaan',13,10
	   db 'kill -poistaa VgaBlankin muistista',13,10,'$'
  OnMsg    db 'Nytn pimennys toimii',13,10,'$'
  Already  db ' on jo muistissa',13,10,'$'
  OffMsg   db ' passivoitu',13,10,'$'
  KillMsg  db ' poistettu muistista',13,10,'$'
  NoKillMsg db 'ia ei voida poistaa muistista',13,10,'$'
  NotFound db 'ia ei lydy muistista',13,10,'$'
  NameStr  db 'VgaBlank','$'

END
